#ifndef __JSONFile_h__
#define __JSONFile_h__

#include "JString.h"
#include "File.h"
#include <iostream>
#include <sstream>

namespace coreutils {

   ///
   /// Use the JSONFile object where you need a file based persistent backing store
   /// for the JString style object. 
   ///

   class JSONFile : public JString : public File {

    public:
      JSONFile(ZString path): JString(), File(path, O_RDWR, 0644) {

      }
      
      virtual ~JSONFile() {
         write(*this);
      }

      void changed(ZString key, ZString value) overide;

   };

}

#endif
